Summary: The Linux kernel (the core of the Linux operating system)
Name: kernel
%define KERNELRELEASE 2.4.19-rmk7-nw4
Version: 2.4.19
Release: 10
License: GPL
Group: System Environment/Kernel
ExclusiveArch: armv4l
ExclusiveOS: Linux
AutoReqProv: no
BuildRoot: %{_tmppath}/kernel-root

Source0: ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-2.4.19.tar.bz2
Patch1: ftp://ftp.arm.linux.org.uk/pub/linux/arm/kernel/v2.4/patch-2.4.19-rmk7.bz2
Patch2: ftp://ftp.netwinder.org/pub/netwinder/kernel/patches/v2.4/patch-2.4.19-rmk7-nw4.gz
Patch3: ftp://ftp.netwinder.org/pub/netwinder/kernel/patches/patch-2.4.19-rmk7-nw4-freeswan-1.99.gz

%package source
Summary: The source code for the Linux kernel.
Group: Development/System
Provides: kernel-headers

%package headers
Summary: Header files for the Linux kernel.
Group: Development/System

%description
The kernel package contains the Linux kernel (vmlinuz), the core of your
Red Hat Linux operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

%description source
The kernel-source package contains the source code files for the Linux
kernel. These source files are needed to build most C programs, since
they depend on the constants defined in the source code. The source
files can also be used to build a custom kernel that is better tuned
to your particular hardware, if you are so inclined (and you know what
you're doing).

%description headers
Kernel-headers includes the C header files for the Linux kernel.  The
header files define structures and constants that are needed for
building most standard programs and are also needed for rebuilding the
kernel.

###
### prep
###

%prep
%setup0 -n linux-2.4.19 -q
%patch1 -p1
%patch2 -p1
%patch3 -p1

###
### build
###

%build
make netwinder_config
make oldconfig
make dep
make Image
make modules

###
### install
###

%install
rm -rf $RPM_BUILD_ROOT

# Install the kernel
mkdir -p $RPM_BUILD_ROOT/boot
install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-%{KERNELRELEASE}
install -m 755 arch/arm/boot/Image $RPM_BUILD_ROOT/boot/vmlinux-%{KERNELRELEASE}

# Install the kernel modules
mkdir -p $RPM_BUILD_ROOT/lib/modules/%{KERNELRELEASE}
INSTALL_MOD_PATH=$RPM_BUILD_ROOT make modules_install

# Cleanup source and install it
make distclean
make netwinder_config
make oldconfig
make symlinks
make include/linux/version.h
mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{KERNELRELEASE}
tar cf - . | (cd $RPM_BUILD_ROOT/usr/src/linux-%{KERNELRELEASE}; tar xf -)

###
### clean
###

%clean
rm -rf $RPM_BUILD_ROOT

###
### scripts
###

%post
ln -sf vmlinux-%{KERNELRELEASE} /boot/vmlinux
ln -sf System.map-%{KERNELRELEASE} /boot/System.map

%post source
ln -sf linux-%{KERNELRELEASE} /usr/src/linux

###
### file lists
###

%files 
%defattr(-,root,root)
/boot/*
/lib/modules/%{KERNELRELEASE}

%files source
%defattr(-,root,root)
/usr/src/linux-%{KERNELRELEASE}

%files headers
%defattr(-,root,root)
/usr/src/linux-%{KERNELRELEASE}/include

%changelog
* Mon Dec 10 2001 Ralph Siemsen <ralphs@netwinder.org>
- Generic kernel spec file for ARM architecture.
